commit d7f58da27596d9dae5d44f75b57216a46080d2cd
Author: Florent Torregrosa <florent.torregrosa@centrale-marseille.fr>
Date:   Fri May 16 22:53:22 2014 +0200

    Switch MAYO on version 7.x-2.0 to be adaptative.

diff --git a/drupal7/sites/all/themes/mayo/color/color.inc b/drupal7/sites/all/themes/mayo/color/color.inc
index 8b0d6aa4..c6c061d3 100644
--- a/drupal7/sites/all/themes/mayo/color/color.inc
+++ b/drupal7/sites/all/themes/mayo/color/color.inc
@@ -1,4 +1,8 @@
 <?php
+/**
+ * @file
+ * Implements color module theme specific settings.
+ */
 
 // Pass some settings to JavaScript for the live preview.
 drupal_add_js(array('color' => array('logo' => theme_get_setting('logo', 'mayo'))), 'setting');
diff --git a/drupal7/sites/all/themes/mayo/color/preview.js b/drupal7/sites/all/themes/mayo/color/preview.js
index d0942a50..d74c8d7c 100644
--- a/drupal7/sites/all/themes/mayo/color/preview.js
+++ b/drupal7/sites/all/themes/mayo/color/preview.js
@@ -1,3 +1,7 @@
+/**
+ * @file
+ * Updates the live preview for MAYO theme settings.
+ */
 
 (function ($) {
   Drupal.color = {
diff --git a/drupal7/sites/all/themes/mayo/config.rb b/drupal7/sites/all/themes/mayo/config.rb
new file mode 100644
index 00000000..9a0240e9
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/config.rb
@@ -0,0 +1,29 @@
+# Require any additional compass plugins here.
+#require "susy"
+
+# Set this to the root of your project when deployed:
+http_path = "/"
+css_dir = "css"
+sass_dir = "sass"
+images_dir = "images"
+javascripts_dir = "js"
+#fonts_dir = "css/fonts"
+
+# You can select your preferred output style here (can be overridden via the command line):
+# output_style = :expanded or :nested or :compact or :compressed
+
+# To enable relative paths to assets via compass helper functions. Uncomment:
+relative_assets = true
+
+# To disable debugging comments that display the original location of your selectors. Uncomment:
+# line_comments = false
+
+# If you prefer the indented syntax, you might want to regenerate this
+# project again passing --syntax sass, or you can uncomment this:
+# preferred_syntax = :sass
+# and then run:
+# sass-convert -R --from scss --to sass sass scss && rm -rf sass && mv scss sass
+preferred_syntax = :scss
+
+
+line_comments = false # by Compass.app 
\ No newline at end of file
diff --git a/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.builders.inc b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.builders.inc
new file mode 100644
index 00000000..6d0d7db0
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.builders.inc
@@ -0,0 +1,56 @@
+<?php
+
+/**
+ * @file
+ * Page Layout CSS Builder.
+ */
+
+global $theme_key, $theme_name;
+$theme_name = $theme_key;
+$_path_to_mayo = drupal_get_path('theme', 'mayo');
+require_once($_path_to_mayo . '/inc/plugins.inc');
+
+/**
+ * Build Page Layouts
+ *
+ * Unlike the Panels layouts which hold CSS in their data array the Page layout
+ * plugins each include a unique CSS builder function. This is required because
+ * page layouts are all bespoke and can accept arbitrary user input for the
+ * sidebar widths and must support three value units - pixles, em's and
+ * percentages.  In other words building a one-size-fits-all builder function
+ * would be overly complex and its far more flexible for themers to be able to
+ * define thier own.
+ *
+ * As values come in from the submit function they are dispatched to the right
+ * builder function.
+ *
+ * @param $method, tells the function which layout builder function to call.
+ * @param $sidebar_first, an arbitrary numeric value.
+ * @param $sidebar_second, an arbitrary numeric value.
+ * @param $sidebar_unit, one of px, em or %.
+ * @param $theme_name, the active theme.
+ *
+ * @see three_col_grail_layout() for an example of a builder function with docs.
+ */
+function mayo_build_page_layout($method, $sidebar_first, $sidebar_second, $sidebar_unit, $theme_name = NULL) {
+  // Use the passed in theme_name, else grab it from global $theme_key
+  if ($theme_name == NULL) {
+    global $theme_key;
+    $theme_name = $theme_key;
+  }
+
+  $output = '';
+
+  // We need to invoke mayo_load_plugins() to get the function names, this is
+  // rather expensive but we're in a submit function so IMO this is OK.
+  mayo_load_plugins($theme_name, $plugin_type = 'page_layout');
+
+  $builder_functions = page_layouts_data_structure($theme_name);
+  foreach ($builder_functions as $function_prefix => $redundant_values) {
+    if ($method === $function_prefix) {
+      $function = $function_prefix . '_layout';
+      $output = $function($sidebar_first, $sidebar_second, $sidebar_unit);
+    }
+  }
+  return $output;
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.inc b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.inc
new file mode 100644
index 00000000..03711312
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.inc
@@ -0,0 +1,41 @@
+<?php
+
+/**
+ * @file
+ * Process all form values. Uses multiple other include files and helper
+ * functions to handle various operations.
+ */
+global $_path_to_mayo;
+$_path_to_mayo = drupal_get_path('theme', 'mayo');
+
+// Helper functions for processing the page layout.
+include($_path_to_mayo . '/inc/forms/mayo.submit.builders.inc');
+
+/**
+ * Custom submit function - this mostly builds and saves stylesheets for
+ * various features such as the responsive layout and font styles.
+ *
+ * @param $form
+ * @param $form_state
+ */
+function mayo_settings_submit($form, &$form_state) {
+  global $_path_to_mayo;
+
+  // Set form_state values into one variable
+  $values = $form_state['values'];
+
+  // Get the active theme name, $theme_key will return the admin theme
+  $theme_name = $form_state['build_info']['args'][0];
+
+  // Set the path variable to the right path
+  $path = 'public://mayo/' . $theme_name . '_files';
+  $values['path'] = $path;
+
+  // Set up the files directory for the generated files
+  file_prepare_directory($path, FILE_CREATE_DIRECTORY);
+  variable_set('theme_' . $theme_name . '_files_directory', $path);
+
+  // Include processing for page & panels layouts, and responsive styles
+  require_once($_path_to_mayo . '/inc/forms/mayo.submit.responsive.inc');
+  mayo_submit_reponsive($values, $theme_name, $path);
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.responsive.inc b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.responsive.inc
new file mode 100644
index 00000000..97516130
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/forms/mayo.submit.responsive.inc
@@ -0,0 +1,178 @@
+<?php
+
+/**
+ * @file
+ * Build and save the responsive layout.
+ *
+ * This is the main submit handler for building the layout.
+ * The output is a stylesheet saved to public
+ * files - the main responsive layout.
+ */
+function mayo_submit_reponsive($values, $theme_name, $path) {
+  global $_path_to_mayo;
+  // Set up some paths we use to get and save files
+  $path_to_responsive_css = drupal_get_path('theme', $theme_name) . '/css/';
+  $path_to_panels_css = $_path_to_mayo . '/layouts/css/';
+
+  // Get the page layout config array
+  $layout_variables = assemble_page_layout();
+
+  // $layouts will hold all the page level layouts
+  $layouts = array();
+
+  // Initialize the $is_default_layout variable, we use this to test against
+  $is_default_layout = 'smalltouch-portrait';
+
+  // Holds all styles from the responsive stylesheets
+  $responsive_styles = array();
+
+  // Smalltouch Landscape
+  if ($values['smalltouch_landscape_layout']) {
+
+    $device = 'smalltouch_landscape';
+
+    // Build an array of page layout settings values
+    foreach ($layout_variables as $key => $value) {
+      if (isset($values["$device" . '_' . "$value"])) {
+        $smalltouch_landscape_layout_data[$value] = check_plain($values["$device" . '_' . "$value"]);
+      }
+    }
+    $layout = mayo_build_page_layout($smalltouch_landscape_layout_data['layout'], $smalltouch_landscape_layout_data['sidebar_first'], $smalltouch_landscape_layout_data['sidebar_second'], $smalltouch_landscape_layout_data['sidebar_unit'], $theme_name);
+
+    $method = $smalltouch_landscape_layout_data['layout'];
+    $comment = "/* $device $method */\n";
+    $width = "\n" . '#page-wrapper {width:' . $smalltouch_landscape_layout_data['page_width'] . $smalltouch_landscape_layout_data['page_unit'] . '}';
+    $media_query = $smalltouch_landscape_layout_data['media_query'];
+
+    // Build the styles string
+    $styles = $width . "\n" . $layout;
+
+    // CSS wrapped in the media query
+    $css = $comment . '@media ' . $media_query . ' {' . $styles . "\n" . '}';
+
+    // Get and wrap the responsive CSS styles in the relative media query
+    $responsive_smalltouch_landscape_css = '';
+    $layouts[] = $css;
+  }
+
+  // Tablet Portrait
+  if ($values['tablet_portrait_layout']) {
+
+    $device = 'tablet_portrait';
+
+    // Build an array of page layout settings values
+    foreach ($layout_variables as $key => $value) {
+      if (isset($values["$device" . '_' . "$value"])) {
+        $tablet_portrait_layout_data[$value] = check_plain($values["$device" . '_' . "$value"]);
+      }
+    }
+    // Workaround upgrade issues for some settings
+    if ($tablet_portrait_layout_data['layout'] == 'two_col_stack') {
+      $tablet_portrait_layout_data['layout'] = 'two_sidebars_right_stack';
+    }
+    $layout = mayo_build_page_layout($tablet_portrait_layout_data['layout'], $tablet_portrait_layout_data['sidebar_first'], $tablet_portrait_layout_data['sidebar_second'], $tablet_portrait_layout_data['sidebar_unit'], $theme_name);
+
+    $method = $tablet_portrait_layout_data['layout'];
+    $comment = "/* $device $method */\n";
+    $width = "\n" . '#page-wrapper {width:' . $tablet_portrait_layout_data['page_width'] . $tablet_portrait_layout_data['page_unit'] . '}';
+    $media_query = $tablet_portrait_layout_data['media_query'];
+
+    // Build the styles string
+    $styles = $width . "\n" . $layout;
+
+    // CSS wrapped in the media query
+    $css = $comment . '@media ' . $media_query . ' {' . $styles . "\n" . '}';
+    $layouts[] = $css;
+  }
+
+  // Tablet Landscape
+  if ($values['tablet_landscape_layout']) {
+
+    $device = 'tablet_landscape';
+
+    // Build an array of page layout settings values
+    foreach ($layout_variables as $key => $value) {
+      if (isset($values["$device" . '_' . "$value"])) {
+        $tablet_landscape_layout_data[$value] = check_plain($values["$device" . '_' . "$value"]);
+      }
+    }
+    // Workaround upgrade issues for some settings
+    if ($tablet_portrait_layout_data['layout'] == 'two_col_stack') {
+      $tablet_portrait_layout_data['layout'] = 'two_sidebars_right_stack';
+    }
+    $layout = mayo_build_page_layout($tablet_landscape_layout_data['layout'], $tablet_landscape_layout_data['sidebar_first'], $tablet_landscape_layout_data['sidebar_second'], $tablet_landscape_layout_data['sidebar_unit'], $theme_name);
+
+    $method = $tablet_landscape_layout_data['layout'];
+    $comment = "/* $device $method */\n";
+    $width = "\n" . '#page-wrapper {width:' . $tablet_landscape_layout_data['page_width'] . $tablet_landscape_layout_data['page_unit'] . '}';
+    $media_query = $tablet_landscape_layout_data['media_query'];
+
+    // Build the styles string
+    $styles = $width . "\n" . $layout;
+
+    // CSS wrapped in the media query
+    $css = $comment . '@media ' . $media_query . ' {' . $styles . "\n" . '}';
+    $layouts[] = $css;
+  }
+  // Standard Layout (bigscreen)
+  if ($values['bigscreen_layout']) {
+
+    $device = 'bigscreen';
+    // Build an array of page layout settings values
+    foreach ($layout_variables as $key => $value) {
+      if (isset($values["$device" . '_' . "$value"])) {
+        $bigscreen_layout_data[$value] = check_plain($values["$device" . '_' . "$value"]);
+      }
+    }
+    $layout = mayo_build_page_layout($bigscreen_layout_data['layout'], $bigscreen_layout_data['sidebar_first'], $bigscreen_layout_data['sidebar_second'], $bigscreen_layout_data['sidebar_unit'], $theme_name);
+
+    $method = $bigscreen_layout_data['layout'];
+    $comment = "/* $device $method */";
+    $width = "\n" . '#page-wrapper {width:' . $bigscreen_layout_data['page_width'] . $bigscreen_layout_data['page_unit'] . '}';
+    $media_query = $bigscreen_layout_data['media_query'];
+
+    // Standard layout can have a max-width
+    $values['bigscreen_set_max_width'] = 0;
+    if ($values['bigscreen_set_max_width'] === 1 && $bigscreen_layout_data['page_unit'] === '%') {
+      if (!empty($values['bigscreen_max_width'])) {
+        $width = "\n" . '#page-wrapper {width:' . $bigscreen_layout_data['page_width'] . $bigscreen_layout_data['page_unit'] . ';max-width:' . $values['bigscreen_max_width'] . $values['bigscreen_max_width_unit'] . '}';
+      }
+      else {
+        $width = "\n" . '#page-wrapper {width:' . $bigscreen_layout_data['page_width'] . $bigscreen_layout_data['page_unit'] . ';max-width:' . $values['bigscreen_max_width'] . $values['bigscreen_max_width_unit'] . '}';
+      }
+    }
+
+    // Build the styles string
+    $styles = $width . "\n" . $layout;
+    $css = $comment . "\n" . '@media ' . $media_query . ' {' . $styles . "\n" . '}';
+
+    // add $css to the layouts array
+    $layouts[] = $css;
+  }
+  //****** END bigscreen layout ******//
+
+  // Get and wrap the responsive CSS styles in the relative media query
+  // responsive layout
+  $responsive_layout_data = implode("\n", $layouts);
+  $responsive_layout = $responsive_layout_data;
+
+  // Aggregate the design stylesheets
+  $responsive_css = implode("\n", $responsive_styles);
+
+  // Regex relative paths. This mimics Drupal core drupal_build_css_cache(), but
+  // its not as powerful because assets must be relative to the theme root.
+  $_base = base_path() . $path_to_responsive_css;
+  _drupal_build_css_path(NULL, $_base);
+  $responsive_css = preg_replace_callback('/url\(\s*[\'"]?(?![a-z]+:|\/+)([^\'")]+)[\'"]?\s*\)/i', '_drupal_build_css_path', $responsive_css);
+
+  // Build a keyed array: file names as key, layout data as value
+  $files = array(
+    "$theme_name.responsive.layout" => $responsive_layout,
+  );
+
+  // Loop over the array and save each file, and we're done!
+  foreach ($files as $key => $value) {
+    $filepath = "$path/$key.css";
+    file_unmanaged_save_data($value, $filepath, FILE_EXISTS_REPLACE);
+  }
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/forms/mayo.validate.inc b/drupal7/sites/all/themes/mayo/inc/forms/mayo.validate.inc
new file mode 100644
index 00000000..ae4a33d2
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/forms/mayo.validate.inc
@@ -0,0 +1,42 @@
+<?php
+
+/**
+ * @file
+ * Validatation for some of the theme settings.
+ *
+ * @param $form
+ * @param $form_state
+ */
+function mayo_settings_validate($form, &$form_state) {
+  $values = $form_state['values'];
+  $theme_name = $form_state['build_info']['args'][0];
+
+  // Validate our form #state required fields, #states are UI only.
+  // Bigscreen
+  if (empty($values['bigscreen_sidebar_first'])) {
+    form_set_error('bigscreen_sidebar_first', t('Standard Layout <em>First sidebar</em> width is empty - you must enter a value.'));
+  }
+  if (empty($values['bigscreen_sidebar_second'])) {
+    form_set_error('bigscreen_sidebar_second', t('Standard Layout <em>Second sidebar</em> width is empty - you must enter a value.'));
+  }
+
+  // Tablet
+  if (empty($values['tablet_landscape_sidebar_first'])) {
+    form_set_error('tablet_landscape_sidebar_first', t('Tablet Landscape <em>First sidebar</em> width is empty - you must enter a value.'));
+  }
+  if ($values['tablet_landscape_layout'] === 'three_col_grail' || $values['tablet_landscape_layout'] === 'two_sidebars_left' || $values['tablet_landscape_layout'] === 'two_sidebars_right') {
+    if (empty($values['tablet_landscape_sidebar_second'])) {
+      form_set_error('tablet_landscape_sidebar_second', t('Tablet Landscape <em>First sidebar</em> width is empty - you must enter a value. The layout you selected requires values for both sidebars.'));
+    }
+  }
+
+  // Smalltouch
+  if ($values['smalltouch_landscape_layout'] === 'one_col_vert') {
+    if (empty($values['smalltouch_landscape_sidebar_first'])) {
+      form_set_error('smalltouch_landscape_sidebar_first', t('Smalltouch First Sidebar width is empty - enter a value or choose another layout.'));
+    }
+    if (empty($values['smalltouch_landscape_sidebar_second'])) {
+      form_set_error('smalltouch_landscape_sidebar_second', t('Smalltouch Second Sidebar width is empty - enter a value or choose another layout.'));
+    }
+  }
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/get.inc b/drupal7/sites/all/themes/mayo/inc/get.inc
new file mode 100644
index 00000000..a787af24
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/get.inc
@@ -0,0 +1,59 @@
+<?php
+
+/**
+ * @file
+ * Provides frequently used functions that get theme info, settings and
+ * other data.
+ */
+
+/**
+ * Return the info file array for a particular theme, usually the active theme.
+ * Simple wrapper function for list_themes().
+ *
+ * @param $theme_name
+ */
+function mayo_get_info($theme_name) {
+  $info = drupal_static(__FUNCTION__, array());
+  if (empty($info)) {
+    $lt = list_themes();
+    foreach ($lt as $key => $value) {
+      if ($theme_name == $key) {
+        $info = $lt[$theme_name]->info;
+      }
+    }
+  }
+
+  return $info;
+}
+
+/**
+ * Returns an array keyed by theme name.
+ *
+ * Return all the info file data for a particular theme including base
+ * themes. Parts of this function are shamelessly ripped from Drupal core's
+ * _drupal_theme_initialize().
+ *
+ * @param $theme_name, usually the active theme.
+ */
+function mayo_get_info_trail($theme_name) {
+  $info_trail = drupal_static(__FUNCTION__, array());
+  if (empty($info_trail)) {
+    $lt = list_themes();
+
+    // First check for base themes and get info
+    $base_theme = array();
+    $ancestor = $theme_name;
+    while ($ancestor && isset($lt[$ancestor]->base_theme)) {
+      $ancestor = $lt[$ancestor]->base_theme;
+      $base_theme[] = $lt[$ancestor];
+    }
+    foreach ($base_theme as $base) {
+      $info_trail[$base->name]['info'] = $base->info;
+    }
+
+    // Now the active theme
+    $info_trail[$theme_name]['info'] = $lt[$theme_name]->info;
+  }
+
+  return $info_trail;
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/load.inc b/drupal7/sites/all/themes/mayo/inc/load.inc
new file mode 100644
index 00000000..6ce65f92
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/load.inc
@@ -0,0 +1,57 @@
+<?php
+global $_theme_name;
+$_theme_name = $GLOBALS['theme_key'];
+
+/**
+ * @file
+ * Provides frequently used functions that load something, ususally CSS or JS
+ * files, or that provide assistance to those loaders.
+ */
+
+/**
+ * Load stylesheet to set the layout.
+ *
+ * Each time you save the theme settings MAYO builds a layout stylesheet:
+ * The file is named: themeName.responsive.layout.css
+ *
+ * @param $path
+ * @param $theme_name
+ */
+function mayo_load_layout_css($path, $theme_name) {
+  global $_theme_name;
+  // Get the info file data
+  $info = mayo_get_info($theme_name);
+
+  // Load the responsive layout
+  $filepath = $path . '/' . $theme_name . '.responsive.layout.css';
+  $media_query = 'only screen'; // keyword "only" hide this from unsupporting user agents
+  mayo_load_subtheme_responsive_styles($filepath, $media_query, $theme_name, $weight = 0);
+}
+
+/**
+ * Load Sub-theme Responsive Stylesheets.
+ * Wrapper function for drupal_add_css() that takes advantage of Drupals's
+ * CSS aggregation logic to trick Drupal into always loading responsive
+ * stylesheets in link elements.
+ *
+ * This is almost always called from mayo_preprocess_html(), only in
+ * a rare instance might this be called from a sub-theme (to load additional
+ * responsive stylesheets).
+ *
+ * @param $filepath, path to the CSS file.
+ * @param $media_query, the media query from theme settings.
+ * @param $theme_name, the active theme.
+ * @param $weight, optional.
+ */
+function mayo_load_subtheme_responsive_styles($filepath, $media_query, $theme_name, $weight = 0) {
+  if (file_exists($filepath)) {
+    drupal_add_css($filepath, array(
+      'preprocess' => variable_get('preprocess_css', '') == 1 ? TRUE : FALSE,
+      'group' => CSS_THEME,
+      'media' => $media_query,
+      'every_page' => TRUE,
+      'weight' => $weight,
+      )
+    );
+  }
+}
diff --git a/drupal7/sites/all/themes/mayo/inc/plugins.inc b/drupal7/sites/all/themes/mayo/inc/plugins.inc
new file mode 100644
index 00000000..5d99ffce
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/inc/plugins.inc
@@ -0,0 +1,225 @@
+<?php
+
+/**
+ * @file
+ * MAYO plugin sub-system.
+ */
+
+/**
+ * Find and return all plugins.
+ *
+ * This will search all base themes and the active theme for "plugins" in their
+ * info files, and return all plugins directories.
+ * MAYO page layouts uses:
+ * - "plugins[page_layout][layout] = layouts/core"
+ *
+ * @param $theme_name, usually the active theme.
+ */
+function mayo_get_plugins($theme_name) {
+  $plugins = drupal_static(__FUNCTION__, array());
+  if (empty($plugins)) {
+      $plugins_list = array();
+      $themes_info = mayo_get_info_trail($theme_name);
+      // Look for and get all the plugins
+      if (!empty($themes_info)) {
+        foreach ($themes_info as $this_theme => $theme_info) {
+          foreach ($theme_info as $info) {
+            if (array_key_exists('plugins', $info)) {
+              foreach ($info['plugins'] as $plugin_type => $types) {
+                $plugins_list[$this_theme][$plugin_type] = $types;
+              }
+            }
+          }
+        }
+        array_unique($plugins_list);
+        $plugins = $plugins_list;
+      }
+  }
+  return $plugins;
+}
+
+/**
+ * Return the paths to all plugin providers plugin directories, this usually
+ * means themes - both base themes and sub-themes that include plugin directory
+ * declarations in their info files.
+ *
+ * @param $theme_name, ususally the active theme.
+ */
+function mayo_get_plugins_paths($theme_name) {
+  $provider_paths = array();
+  $plugins_list = mayo_get_plugins($theme_name);
+
+  foreach ($plugins_list as $plugin_provider => $provider) {
+    foreach ($provider as $plugin_type => $types) {
+      foreach ($types as $type => $path) {
+        $provider_path = drupal_get_path('theme', $plugin_provider) . '/' . $path;
+        $provider_paths[$plugin_provider][$plugin_type][$type] = $provider_path;
+      }
+    }
+  }
+
+  return $provider_paths;
+}
+
+/**
+ * Returns all files for plugins of a particular type.
+ * This is called from mayo_load_plugins(), cannot be cached else it will return
+ * stale data at some point.
+ *
+ * @param $theme_name
+ */
+function mayo_get_plugins_files($theme_name) {
+  $plugins_files = array();
+  $plugins_list = mayo_get_plugins($theme_name);
+
+  $extension = 'inc';
+  foreach ($plugins_list as $plugin_provider => $provider) {
+    foreach ($provider as $plugin_type => $types) {
+      foreach ($types as $type => $path) {
+        $provider_path = drupal_get_path('theme', $plugin_provider) . '/' . $path;
+        $plugins_files[$plugin_provider][$plugin_type][$type] = file_scan_directory($provider_path, '/\.' . $extension . '$/', array('key' => 'name'));
+      }
+    }
+  }
+
+  return $plugins_files;
+}
+
+/**
+ * Extract plugin data structures.
+ *
+ * In essence what this does is return the data strutures (arrays) for all
+ * plugins of a particular type. MAYO only uses the "page_layout" type.
+ * This is hard to cache because it takes the
+ * $plugin_type parameter, so everything else that calls this is heavily cached
+ * instead. It does support an "everything else" plugin type, whatever that is.
+ *
+ * @param $theme_name, usually the active theme.
+ * @param $plugin_type, the plugin type you need to return, usually one of
+ * "panels" or "page_layout".
+ */
+function mayo_load_plugins($theme_name, $plugin_type) {
+  $plugin_data_structures = array();
+  $plugins_list = mayo_get_plugins_files($theme_name);
+  $plugins_array = array();
+  foreach ($plugins_list as $plugin_provider => $plugin_types) {
+    $plugin_providers[] = $plugin_provider;
+    foreach ($plugin_types as $type => $plugins) {
+      if ($type === $plugin_type) {
+        foreach ($plugins as $ptypes => $plugin) {
+          $plugins_array[$plugin_provider][$type] = $plugin;
+        }
+      }
+    }
+  }
+  $plugin_files = array();
+  foreach ($plugins_array as $provider => $types) {
+    foreach ($types as $key => $value) {
+      $plugin_files = array_merge_recursive($plugin_files, $value);
+    }
+  }
+
+  foreach ($plugin_files as $file_data) {
+
+    include_once(DRUPAL_ROOT . '/' . $file_data->uri);
+
+    // page_layout
+    if ($plugin_type === 'page_layout') {
+      $identifier = $file_data->name;
+      $page_layout_function = $identifier;
+      if (function_exists($page_layout_function)) {
+        $plugin_data_structures[] = $page_layout_function();
+      }
+    }
+
+    // everything else
+    elseif ($plugin_type !== 'panels' && $plugin_type !== 'page_layout') {
+      $identifier = $file_data->name;
+      $function = $identifier;
+      if (function_exists($function)) {
+        $plugin_data_structures[] = $function();
+      }
+      else {
+        drupal_set_message(t('You defined an existing plugin type but no functions exists that match. If you are using Panels then you must use the "function method" in your plugins.'), 'error');
+      }
+    }
+  }
+
+  if (empty($plugin_data_structures)) {
+    return;
+  }
+  return $plugin_data_structures;
+}
+
+/**
+ * Return Page layout data structures.
+ * This returns the full data structures for all page layout plugins. Because
+ * this can be a lot of data and appears to be computationally expensive to get
+ * it is cached in the cache table.
+ *
+ * @param $theme_name, the active theme.
+ */
+function page_layouts_data_structure($theme_name = NULL) {
+  // Use the passed in theme_name, else grab it from the global variable
+  if ($theme_name == NULL) {
+    global $theme_key;
+    $theme_name = $theme_key;
+  }
+
+  $page_data_structure = drupal_static(__FUNCTION__, array());
+  if (empty($page_data_structure)) {
+      $data_structure = mayo_load_plugins($theme_name, $plugin_type = 'page_layout');
+      foreach ($data_structure as $plugin => $datum) {
+        foreach ($datum as $method => $layout) {
+          $page_data_structure[$method] = $layout;
+        }
+      }
+  }
+  return $page_data_structure;
+}
+
+/**
+ * Return option arrays for forms.
+ * Returns the options for radio lists in the page layout settings in the
+ * appearance theme settings.
+ *
+ * @param $theme_name
+ */
+function page_layouts_device_group_options($theme_name) {
+  $device_group_options = drupal_static(__FUNCTION__, array());
+  if (empty($device_group_options)) {
+    $layout_methods = page_layouts_data_structure();
+    foreach ($layout_methods as $method => $values) {
+      foreach ($values as $key => $value) {
+        if ($key == 'device_groups') {
+          $method_values[$method] = $value;
+        }
+      }
+    }
+    foreach ($method_values as $this_method => $these_values) {
+      foreach ($these_values as $k => $dv) {
+        $device_group_options[$dv][] = $this_method;
+      }
+    }
+  }
+
+  return $device_group_options;
+}
+
+/**
+ * Base config for page layout builder.
+ * This is used in mayo_core.submit.responsive.inc to help retrieve the form
+ * values for each device groups layout.
+ */
+function assemble_page_layout() {
+  $variables_array = array(
+    'layout',
+    'media_query',
+    'page_width',
+    'page_unit',
+    'sidebar_first',
+    'sidebar_second',
+    'sidebar_unit',
+  );
+  return $variables_array;
+}
diff --git a/drupal7/sites/all/themes/mayo/js/mayo-columns.js b/drupal7/sites/all/themes/mayo/js/mayo-columns.js
index 704cad7c..ab54854d 100644
--- a/drupal7/sites/all/themes/mayo/js/mayo-columns.js
+++ b/drupal7/sites/all/themes/mayo/js/mayo-columns.js
@@ -1,6 +1,6 @@
 /**
  * @file
- * Equolize the column height in a specified group
+ * Equalize the column height in a specified group.
  */
 jQuery(document).ready(function() {
   mayoEqualHeight(jQuery("#top-columns .column-block"));
diff --git a/drupal7/sites/all/themes/mayo/js/mayo-fontsize.js b/drupal7/sites/all/themes/mayo/js/mayo-fontsize.js
index 38b8caac..935417e6 100644
--- a/drupal7/sites/all/themes/mayo/js/mayo-fontsize.js
+++ b/drupal7/sites/all/themes/mayo/js/mayo-fontsize.js
@@ -1,6 +1,6 @@
 /**
  * @file
- * Adds javascript functions for font resizing
+ * Adds javascript functions for font resizing.
  */
 jQuery(document).ready(function() {
   var originalFontSize = jQuery('body').css('font-size');
diff --git a/drupal7/sites/all/themes/mayo/js/mayo.js b/drupal7/sites/all/themes/mayo/js/mayo.js
index 0ca15066..8862bc00 100644
--- a/drupal7/sites/all/themes/mayo/js/mayo.js
+++ b/drupal7/sites/all/themes/mayo/js/mayo.js
@@ -1,6 +1,6 @@
 /**
  * @file
- * Provides the administration JavaScript for the Mayo theme settings page
+ * Provides the administration JavaScript for the Mayo theme settings page.
  */
 
 (function ($) {
diff --git a/drupal7/sites/all/themes/mayo/layouts/core/one_col_stack/one_col_stack.inc b/drupal7/sites/all/themes/mayo/layouts/core/one_col_stack/one_col_stack.inc
new file mode 100644
index 00000000..1a8adbd5
--- /dev/null
+++ b/drupal7/sites/all/themes/mayo/layouts/core/one_col_stack/one_col_stack.inc
@@ -0,0 +1,40 @@
+<?php
+
+/**
+ * @file
+ * Implimentation of a Page Layout Plugin for MAYO.
+ *
+ * @see three_col_grail.inc for detailed documentation.
+ */
+function one_col_stack() {
+  $page_layout['one_col_stack'] = array(
+    'title'    => t('One Column Stacked'),
+    'method'   => 'one_col_stack',
+    'type'     => 'page_layout',
+    'device_groups' => array(
+      'tablet_portrait',
+      'smalltouch_landscape',
+     ),
+  );
+
+  return $page_layout;
+}
+
+/**
+ * CSS Builder for the one_col_stack layout.
+ * Note: this is the only layout for smalltouch portrait, and for mobile first.
+ * All columns and regions are 100% width, stacked.
+ *
+ * @param $sidebar_first, an arbitary numeric value.
+ * @param $sidebar_second, an arbitary numeric value.
+ * @param $sidebar_unit, a value unit, one of px, em or %.
+ */
+function one_col_stack_layout($sidebar_first, $sidebar_second, $sidebar_unit) {
+  $styles = <<<EOF
+#sidebar-first,#sidebar-second {float:none;clear:both;display:block;width:100%;margin-left:0;margin-right:0}
+#top-columns .column-block-wrapper {width: 100% !important; margin-top: 1em;}
+#top-columns .column-block-wrapper .column-block {height: auto ; margin: 0 !important;}
+EOF;
+
+  return $styles;
+}
